package test;

import java.util.*;

import javax.ejb.*;
import javax.naming.*;

public class LookupBean implements SessionBean {
    SessionContext sessionContext;
    public void ejbCreate() throws CreateException {
    }
    public void ejbRemove() {
    }
    public void ejbActivate() {
    }
    public void ejbPassivate() {
    }
    public void setSessionContext(SessionContext sessionContext) {
        this.sessionContext = sessionContext;
    }

    public HashMap lookup() {
        HashMap res = new HashMap();
        try {
            Context ctx = new InitialContext();
            BilHome home = (BilHome) ctx.lookup("local/Bil");
            Iterator bilit = home.findAll().iterator();
            while (bilit.hasNext()) {
                Bil bilbean = (Bil) bilit.next();
                Iterator beskit = bilbean.getBeskrivelse().iterator();
                StringBuffer sb = new StringBuffer("");
                while(beskit.hasNext()) {
                    Beskrivelse beskbean = (Beskrivelse) beskit.next();
                    if(sb.length() > 0) sb.append(" ");
                    sb.append(beskbean.getBeskrivelse());
                }
                res.put(bilbean.getNavn(), sb.toString());
            }
        } catch (NamingException ex) {
            ex.printStackTrace();
        } catch (FinderException ex) {
            ex.printStackTrace();
        }
        return res;
    }
    
    public void add(int id, String navn, String besk) {
        try {
            Context ctx = new InitialContext();
            BilHome bilhome = (BilHome) ctx.lookup("local/Bil");
            BeskrivelseHome beskhome = (BeskrivelseHome) ctx.lookup("local/Beskrivelse");
            Bil bilbean = bilhome.create(new Integer(id));
            bilbean.setNavn(navn);
            Collection bilbesk = bilbean.getBeskrivelse();
            StringTokenizer st = new StringTokenizer(besk, ",");
            while (st.hasMoreTokens()) {
                int beskid = Integer.parseInt(st.nextToken());
                Beskrivelse beskbean = beskhome.findByPrimaryKey(new Integer(beskid));
                bilbesk.add(beskbean);
            }
            bilbean.setBeskrivelse(bilbesk);
        } catch (NamingException ex) {
            ex.printStackTrace();
        } catch (FinderException ex) {
            ex.printStackTrace();
        } catch (CreateException ex) {
            ex.printStackTrace();
        }
    }
}